!+ Subroutine to transfer spectrum to reduced array.                               RAD_ALL.21956 
!                                                                                  RAD_ALL.21957 
! Purpose:                                                                         RAD_ALL.21958 
!       Spectral data from the large dynamically allocated array                   RAD_ALL.21959 
!       are transferred to the reduced array.                                      RAD_ALL.21960 
!                                                                                  RAD_ALL.21961 
! Method:                                                                          RAD_ALL.21962 
!       Elements are copied across.                                                RAD_ALL.21963 
!                                                                                  RAD_ALL.21964 
! Current Owner of Code: J. M. Edwards                                             RAD_ALL.21965 
!                                                                                  RAD_ALL.21966 
! History:                                                                         RAD_ALL.21967 
!       Version         Date                    Comment                            RAD_ALL.21968 
!       4.0             27-07-95                Original Code                      RAD_ALL.21969 
!                                               (J. M. Edwards)                    RAD_ALL.21970 
!       4.4             03-09-97                Coding changes                     RAD_ALL.21971 
!                                               associated with the                RAD_ALL.21972 
!                                               removal of pointers                RAD_ALL.21973 
!                                               into the spectral data.            RAD_ALL.21974 
!                                               Capability to select               RAD_ALL.21975 
!                                               aerosols added.                    RAD_ALL.21976 
!                                               (J. M. Edwards)                    RAD_ALL.21977 
!                                                                                  RAD_ALL.21978 
! Description of Code:                                                             RAD_ALL.21979 
!   FORTRAN 77  with extensions listed in documentation.                           RAD_ALL.21980 
!                                                                                  RAD_ALL.21981 
!- ---------------------------------------------------------------------           RAD_ALL.21982 
      SUBROUTINE R2_COMPRESS_SPECTRUM(                                             RAD_ALL.21983 
!                       Original Spectrum                                          RAD_ALL.21984 
     &     L_PRESENT                                                               RAD_ALL.21985 
     &   , N_BAND, WAVE_LENGTH_SHORT , WAVE_LENGTH_LONG                            RAD_ALL.21986 
     &   , N_BAND_EXCLUDE, INDEX_EXCLUDE                                           RAD_ALL.21987 
     &   , SOLAR_FLUX_BAND, RAYLEIGH_COEFFICIENT                                   RAD_ALL.21988 
     &   , N_ABSORB, N_BAND_ABSORB, INDEX_ABSORB, TYPE_ABSORB                      RAD_ALL.21989 
     &   , I_BAND_ESFT, K_ESFT, W_ESFT, I_SCALE_ESFT                               RAD_ALL.21990 
     &   , I_SCALE_FNC, SCALE_VECTOR, P_REFERENCE, T_REFERENCE                     RAD_ALL.21991 
     &   , N_DEG_FIT, THERMAL_COEFFICIENT, T_REF_PLANCK                            RAD_ALL.21992 
     &   , I_SPEC_SURFACE, L_SURFACE, SURFACE_ALBEDO                               RAD_ALL.21993 
     &   , N_DIR_ALBEDO_FIT, DIRECT_ALBEDO_PARM, EMISSIVITY_GROUND                 RAD_ALL.21994 
     &   , N_BAND_CONTINUUM, INDEX_CONTINUUM, INDEX_WATER                          RAD_ALL.21995 
     &   , K_CONTINUUM, I_SCALE_FNC_CONT, SCALE_CONTINUUM                          RAD_ALL.21996 
     &   , P_REF_CONTINUUM, T_REF_CONTINUUM                                        RAD_ALL.21997 
     &   , L_DROP_TYPE, I_DROP_PARAMETRIZATION, DROP_PARAMETER_LIST                RAD_ALL.21998 
     &   , DROP_PARM_MIN_DIM, DROP_PARM_MAX_DIM                                    RAD_ALL.21999 
     &   , L_ICE_TYPE, I_ICE_PARAMETRIZATION, ICE_PARAMETER_LIST                   RAD_ALL.22000 
     &   , ICE_PARM_MIN_DIM, ICE_PARM_MAX_DIM                                      RAD_ALL.22001 
     &   , N_AEROSOL, TYPE_AEROSOL                                                 RAD_ALL.22002 
     &   , N_AEROSOL_RETAIN, INDEX_AEROSOL_RETAIN                                  RAD_ALL.22003 
     &   , L_AEROSOL_SPECIES, AEROSOL_ABSORPTION                                   RAD_ALL.22004 
     &   , AEROSOL_SCATTERING, AEROSOL_ASYMMETRY                                   RAD_ALL.22005 
     &   , NHUMIDITY, HUMIDITIES, I_AEROSOL_PARAMETRIZATION                        RAD_ALL.22006 
     &   , L_DOPPLER_PRESENT, DOPPLER_CORRECTION                                   RAD_ALL.22007 
!                       Reduced Spectral Array                                     RAD_ALL.22008 
     &   , NPDR_TYPE, NPDR_BAND, NPDR_EXCLUDE                                      RAD_ALL.22009 
     &   , NPDR_SPECIES, NPDR_ESFT_TERM, NPDR_SCALE_FNC                            RAD_ALL.22010 
     &   , NPDR_SCALE_VARIABLE, NPDR_THERMAL_COEFF                                 RAD_ALL.22011 
     &   , NPDR_SURFACE, NPDR_ALBEDO_PARM                                          RAD_ALL.22012 
     &   , NPDR_CONTINUUM, NPDR_DROP_TYPE, NPDR_ICE_TYPE                           RAD_ALL.22013 
     &   , NPDR_CLOUD_PARAMETER, NPDR_AEROSOL_SPECIES                              RAD_ALL.22014 
     &   , NPDR_HUMIDITIES                                                         RAD_ALL.22015 
     &   , L_PRESENT_RD                                                            RAD_ALL.22016 
     &   , N_BAND_RD, WAVE_LENGTH_SHORT_RD , WAVE_LENGTH_LONG_RD                   RAD_ALL.22017 
     &   , N_BAND_EXCLUDE_RD, INDEX_EXCLUDE_RD                                     RAD_ALL.22018 
     &   , SOLAR_FLUX_BAND_RD, RAYLEIGH_COEFFICIENT_RD                             RAD_ALL.22019 
     &   , N_ABSORB_RD, N_BAND_ABSORB_RD, INDEX_ABSORB_RD                          RAD_ALL.22020 
     &   , TYPE_ABSORB_RD                                                          RAD_ALL.22021 
     &   , I_BAND_ESFT_RD, I_SCALE_ESFT_RD, I_SCALE_FNC_RD                         RAD_ALL.22022 
     &   , K_ESFT_RD, W_ESFT_RD, SCALE_VECTOR_RD                                   RAD_ALL.22023 
     &   , P_REFERENCE_RD, T_REFERENCE_RD                                          RAD_ALL.22024 
     &   , N_DEG_FIT_RD, THERMAL_COEFFICIENT_RD, T_REF_PLANCK_RD                   RAD_ALL.22025 
     &   , I_SPEC_SURFACE_RD, N_DIR_ALBEDO_FIT_RD                                  RAD_ALL.22026 
     &   , L_SURFACE_RD, SURFACE_ALBEDO_RD, DIRECT_ALBEDO_PARM_RD                  RAD_ALL.22027 
     &   , EMISSIVITY_GROUND_RD                                                    RAD_ALL.22028 
     &   , N_BAND_CONTINUUM_RD, INDEX_CONTINUUM_RD, INDEX_WATER_RD                 RAD_ALL.22029 
     &   , I_SCALE_FNC_CONT_RD, K_CONTINUUM_RD, SCALE_CONTINUUM_RD                 RAD_ALL.22030 
     &   , P_REF_CONTINUUM_RD, T_REF_CONTINUUM_RD                                  RAD_ALL.22031 
     &   , I_DROP_PARAMETRIZATION_RD, L_DROP_TYPE_RD                               RAD_ALL.22032 
     &   , DROP_PARAMETER_LIST_RD                                                  RAD_ALL.22033 
     &   , DROP_PARM_MIN_DIM_RD, DROP_PARM_MAX_DIM_RD                              RAD_ALL.22034 
     &   , N_AEROSOL_RD, TYPE_AEROSOL_RD, I_AEROSOL_PARAMETRIZATION_RD             RAD_ALL.22035 
     &   , NHUMIDITY_RD, HUMIDITIES_RD                                             RAD_ALL.22036 
     &   , L_AEROSOL_SPECIES_RD, AEROSOL_ABSORPTION_RD                             RAD_ALL.22037 
     &   , AEROSOL_SCATTERING_RD, AEROSOL_ASYMMETRY_RD                             RAD_ALL.22038 
     &   , I_ICE_PARAMETRIZATION_RD, L_ICE_TYPE_RD                                 RAD_ALL.22039 
     &   , ICE_PARAMETER_LIST_RD                                                   RAD_ALL.22040 
     &   , ICE_PARM_MIN_DIM_RD, ICE_PARM_MAX_DIM_RD                                RAD_ALL.22041 
     &   , L_DOPPLER_PRESENT_RD, DOPPLER_CORRECTION_RD                             RAD_ALL.22042 
     &   )                                                                         RAD_ALL.22043 
!                                                                                  RAD_ALL.22044 
       IMPLICIT NONE                                                               RAD_ALL.22045 
!                                                                                  RAD_ALL.22046 
!                                                                                  RAD_ALL.22047 
!     ------------------------------------------------------------------           RAD_ALL.22048 
!     DECLARATION OF INITIAL SPECTRUM.                                             RAD_ALL.22049 
!     ------------------------------------------------------------------           RAD_ALL.22050 
!     ------------------------------------------------------------------           MXSIZE3A.2     
!     MODULE SETTING MAXIMUM DIMENSIONS OF ARRAYS IN THE RADIATION CODE.           MXSIZE3A.3     
!                                                                                  MXSIZE3A.4     
      INTEGER                                                                      MXSIZE3A.5     
     &     NPD_TYPE                                                                MXSIZE3A.6     
!             NUMBER OF TYPES OF DATA                                              MXSIZE3A.7     
     &   , NPD_BAND                                                                MXSIZE3A.8     
!             NUMBER OF SPECTRAL BANDS                                             MXSIZE3A.9     
     &   , NPD_EXCLUDE                                                             MXSIZE3A.10    
!             NUMER OF EXCLUDED BANDS                                              MXSIZE3A.11    
     &   , NPD_SPECIES                                                             MXSIZE3A.12    
!             NUMBER OF GASEOUS SPECIES                                            MXSIZE3A.13    
     &   , NPD_ESFT_TERM                                                           MXSIZE3A.14    
!             NUMBER OF ESFT TERMS                                                 MXSIZE3A.15    
     &   , NPD_SCALE_FNC                                                           MXSIZE3A.16    
!             NUMBER OF SCALING FUNCTIONS                                          MXSIZE3A.17    
     &   , NPD_SCALE_VARIABLE                                                      MXSIZE3A.18    
!             NUMBER OF SCALING VARIABLES                                          MXSIZE3A.19    
     &   , NPD_SURFACE                                                             MXSIZE3A.20    
!             NUMBER OF SURFACE TYPES                                              MXSIZE3A.21    
     &   , NPD_ALBEDO_PARM                                                         MXSIZE3A.22    
!             NUMBER OF ALBEDO PARAMETERS                                          MXSIZE3A.23    
     &   , NPD_CONTINUUM                                                           MXSIZE3A.24    
!             NUMBER OF CONTINUA                                                   MXSIZE3A.25    
     &   , NPD_DROP_TYPE                                                           MXSIZE3A.26    
!             NUMBER OF DROP TYPES                                                 MXSIZE3A.27    
     &   , NPD_ICE_TYPE                                                            MXSIZE3A.28    
!             NUMBER OF ICE CRYSTAL TYPES                                          MXSIZE3A.29    
     &   , NPD_AEROSOL_SPECIES                                                     MXSIZE3A.30    
!             NUMBER OF AEROSOL SPECIES                                            MXSIZE3A.31    
     &   , NPD_CLOUD_PARAMETER                                                     MXSIZE3A.32    
!             MAX NUMBER OF CLOUD PARAMETERS                                       MXSIZE3A.33    
     &   , NPD_HUMIDITIES                                                          MXSIZE3A.34    
!             MAXIMUM NUMBER OF HUMIDITIES                                         MXSIZE3A.35    
     &   , NPD_THERMAL_COEFF                                                       MXSIZE3A.36    
!             NUMBER OF THERMAL COEFFICIENTS                                       MXSIZE3A.37    
!                                                                                  MXSIZE3A.38    
      PARAMETER(                                                                   MXSIZE3A.39    
     &     NPD_TYPE=15                                                             MXSIZE3A.40    
     &   , NPD_BAND=20                                                             MXSIZE3A.41    
     &   , NPD_EXCLUDE=2                                                           MXSIZE3A.42    
     &   , NPD_SPECIES=15                                                          MXSIZE3A.43    
     &   , NPD_ESFT_TERM=16                                                        MXSIZE3A.44    
     &   , NPD_SCALE_FNC=3                                                         MXSIZE3A.45    
     &   , NPD_SCALE_VARIABLE=4                                                    MXSIZE3A.46    
     &   , NPD_THERMAL_COEFF=9                                                     MXSIZE3A.47    
     &   , NPD_SURFACE=1                                                           MXSIZE3A.48    
     &   , NPD_ALBEDO_PARM=4                                                       MXSIZE3A.49    
     &   , NPD_CONTINUUM=2                                                         MXSIZE3A.50    
     &   , NPD_DROP_TYPE=6                                                         MXSIZE3A.51    
     &   , NPD_ICE_TYPE=7                                                          MXSIZE3A.52    
     &   , NPD_CLOUD_PARAMETER=30                                                  MXSIZE3A.53    
     &   , NPD_AEROSOL_SPECIES=7                                                   MXSIZE3A.54    
     &   , NPD_HUMIDITIES=21                                                       MXSIZE3A.55    
     &   )                                                                         MXSIZE3A.56    
!     ------------------------------------------------------------------           MXSIZE3A.57    
!     ------------------------------------------------------------------           SPDEC3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       SPDEC3A.3     
!                                                                                  SPDEC3A.4     
!     MODULE CONTAINING DECLARATIONS FOR SPECTRAL FILE.                            SPDEC3A.5     
!     ------------------------------------------------------------------           SPDEC3A.6     
!                                                                                  SPDEC3A.7     
!                                                                                  SPDEC3A.8     
!                                                                                  SPDEC3A.9     
!     GENERAL FIELDS:                                                              SPDEC3A.10    
!                                                                                  SPDEC3A.11    
      LOGICAL                                                                      SPDEC3A.12    
     &     L_PRESENT(0: NPD_TYPE)                                                  SPDEC3A.13    
!             FLAG FOR TYPES OF DATA PRESENT                                       SPDEC3A.14    
!                                                                                  SPDEC3A.15    
!                                                                                  SPDEC3A.16    
!                                                                                  SPDEC3A.17    
!     PROPERTIES OF THE SPECTRAL BANDS:                                            SPDEC3A.18    
!                                                                                  SPDEC3A.19    
      INTEGER                                                                      SPDEC3A.20    
     &     N_BAND                                                                  SPDEC3A.21    
!             NUMBER OF SPECTRAL BANDS                                             SPDEC3A.22    
!                                                                                  SPDEC3A.23    
      REAL                                                                         SPDEC3A.24    
     &     WAVE_LENGTH_SHORT(NPD_BAND)                                             SPDEC3A.25    
!             SHORTER WAVELENGTH LIMITS                                            SPDEC3A.26    
     &   , WAVE_LENGTH_LONG(NPD_BAND)                                              SPDEC3A.27    
!             LONGER WAVELENGTH LIMITS                                             SPDEC3A.28    
!                                                                                  SPDEC3A.29    
!                                                                                  SPDEC3A.30    
!                                                                                  SPDEC3A.31    
!     EXCLUSION OF SPECIFIC BANDS FROM PARTS OF THE SPECTRUM:                      SPDEC3A.32    
!                                                                                  SPDEC3A.33    
      INTEGER                                                                      SPDEC3A.34    
     &     N_BAND_EXCLUDE(NPD_BAND)                                                SPDEC3A.35    
!             NUMBER OF EXCLUDED BANDS WITHIN EACH SPECTRAL BAND                   SPDEC3A.36    
     &   , INDEX_EXCLUDE(NPD_EXCLUDE, NPD_BAND)                                    SPDEC3A.37    
!             INDICES OF EXCLUDED BANDS                                            SPDEC3A.38    
!                                                                                  SPDEC3A.39    
!                                                                                  SPDEC3A.40    
!                                                                                  SPDEC3A.41    
!     FIELDS FOR THE SOLAR FLUX:                                                   SPDEC3A.42    
!                                                                                  SPDEC3A.43    
      REAL                                                                         SPDEC3A.44    
     &     SOLAR_FLUX_BAND(NPD_BAND)                                               SPDEC3A.45    
!             FRACTION OF THE INCIDENT SOLAR FLUX IN EACH BAND                     SPDEC3A.46    
!                                                                                  SPDEC3A.47    
!                                                                                  SPDEC3A.48    
!                                                                                  SPDEC3A.49    
!     FIELDS FOR RAYLEIGH SCATTERING:                                              SPDEC3A.50    
!                                                                                  SPDEC3A.51    
      REAL                                                                         SPDEC3A.52    
     &     RAYLEIGH_COEFFICIENT(NPD_BAND)                                          SPDEC3A.53    
!             RAYLEIGH COEFFICIENTS                                                SPDEC3A.54    
!                                                                                  SPDEC3A.55    
!                                                                                  SPDEC3A.56    
!                                                                                  SPDEC3A.57    
!     FIELDS FOR GASEOUS ABSORPTION:                                               SPDEC3A.58    
!                                                                                  SPDEC3A.59    
      INTEGER                                                                      SPDEC3A.60    
     &     N_ABSORB                                                                SPDEC3A.61    
!             NUMBER OF ABSORBERS                                                  SPDEC3A.62    
     &   , N_BAND_ABSORB(NPD_BAND)                                                 SPDEC3A.63    
!             NUMBER OF ABSORBERS IN EACH BAND                                     SPDEC3A.64    
     &   , INDEX_ABSORB(NPD_SPECIES, NPD_BAND)                                     SPDEC3A.65    
!             LIST OF ABSORBERS IN EACH BAND                                       SPDEC3A.66    
     &   , TYPE_ABSORB(NPD_SPECIES)                                                SPDEC3A.67    
!             TYPES OF EACH GAS IN THE SPECTRAL FILE                               SPDEC3A.68    
     &   , I_BAND_ESFT(NPD_BAND, NPD_SPECIES)                                      SPDEC3A.69    
!             NUMBER OF ESFT TERMS IN BAND FOR EACH GAS                            SPDEC3A.70    
     &   , I_SCALE_ESFT(NPD_BAND, NPD_SPECIES)                                     SPDEC3A.71    
!             TYPE OF ESFT SCALING                                                 SPDEC3A.72    
     &   , I_SCALE_FNC(NPD_BAND, NPD_SPECIES)                                      SPDEC3A.73    
!             TYPE OF SCALING FUNCTION                                             SPDEC3A.74    
!                                                                                  SPDEC3A.75    
      REAL                                                                         SPDEC3A.76    
     &     K_ESFT(NPD_ESFT_TERM, NPD_BAND, NPD_SPECIES)                            SPDEC3A.77    
!             ESFT EXPONENTS                                                       SPDEC3A.78    
     &   , W_ESFT(NPD_ESFT_TERM, NPD_BAND, NPD_SPECIES)                            SPDEC3A.79    
!             ESFT WEIGHTS                                                         SPDEC3A.80    
     &   , SCALE_VECTOR(NPD_SCALE_VARIABLE, NPD_ESFT_TERM, NPD_BAND                SPDEC3A.81    
     &        , NPD_SPECIES)                                                       SPDEC3A.82    
!             SCALING PARAMETERS FOR EACH ABSORBER AND TERM                        SPDEC3A.83    
     &   , P_REFERENCE(NPD_SPECIES, NPD_BAND)                                      SPDEC3A.84    
!             REFERENCE PRESSURE FOR SCALING FUNCTION                              SPDEC3A.85    
     &   , T_REFERENCE(NPD_SPECIES, NPD_BAND)                                      SPDEC3A.86    
!             REFERENCE TEMPERATURE FOR SCALING FUNCTION                           SPDEC3A.87    
!                                                                                  SPDEC3A.88    
!                                                                                  SPDEC3A.89    
!                                                                                  SPDEC3A.90    
!     REPRESENTATION OF THE PLANCKIAN:                                             SPDEC3A.91    
!                                                                                  SPDEC3A.92    
      INTEGER                                                                      SPDEC3A.93    
     &     N_DEG_FIT                                                               SPDEC3A.94    
!             DEGREE OF THERMAL POLYNOMIAL                                         SPDEC3A.95    
!                                                                                  SPDEC3A.96    
      REAL                                                                         SPDEC3A.97    
     &     THERMAL_COEFFICIENT(0: NPD_THERMAL_COEFF-1, NPD_BAND)                   SPDEC3A.98    
!             COEFFICIENTS IN POLYNOMIAL FIT TO SOURCE FUNCTION                    SPDEC3A.99    
     &   , T_REF_PLANCK                                                            SPDEC3A.100   
!             PLANCKIAN REFERENCE TEMPERATURE                                      SPDEC3A.101   
!                                                                                  SPDEC3A.102   
!                                                                                  SPDEC3A.103   
!                                                                                  SPDEC3A.104   
!     SURFACE PROPERTIES:                                                          SPDEC3A.105   
!                                                                                  SPDEC3A.106   
      INTEGER                                                                      SPDEC3A.107   
     &     I_SPEC_SURFACE(NPD_SURFACE)                                             SPDEC3A.108   
!             METHOD OF SPECIFYING PROPERTIES OF SURFACE                           SPDEC3A.109   
     &   , N_DIR_ALBEDO_FIT(NPD_SURFACE)                                           SPDEC3A.110   
!             NUMBER OF PARAMETERS FITTING THE DIRECT ALBEDO                       SPDEC3A.111   
!                                                                                  SPDEC3A.112   
      LOGICAL                                                                      SPDEC3A.113   
     &     L_SURFACE(NPD_SURFACE)                                                  SPDEC3A.114   
!             SURFACE TYPES INCLUDED                                               SPDEC3A.115   
!                                                                                  SPDEC3A.116   
      REAL                                                                         SPDEC3A.117   
     &     SURFACE_ALBEDO(NPD_BAND, NPD_SURFACE)                                   SPDEC3A.118   
!             SURFACE ALBEDOS                                                      SPDEC3A.119   
     &   , DIRECT_ALBEDO_PARM(0: NPD_ALBEDO_PARM, NPD_BAND, NPD_SURFACE)           SPDEC3A.120   
!             COEFFICIENTS FOR FITTING DIRECT ALBEDO                               SPDEC3A.121   
     &   , EMISSIVITY_GROUND(NPD_BAND, NPD_SURFACE)                                SPDEC3A.122   
!             SURFACE EMISSIVITIES                                                 SPDEC3A.123   
!                                                                                  SPDEC3A.124   
!                                                                                  SPDEC3A.125   
!                                                                                  SPDEC3A.126   
!     FIELDS FOR CONTINUA:                                                         SPDEC3A.127   
!                                                                                  SPDEC3A.128   
      INTEGER                                                                      SPDEC3A.129   
     &     N_BAND_CONTINUUM(NPD_BAND)                                              SPDEC3A.130   
!             NUMBER OF CONTINUA IN EACH BAND                                      SPDEC3A.131   
     &   , INDEX_CONTINUUM(NPD_BAND, NPD_CONTINUUM)                                SPDEC3A.132   
!             LIST OF CONTINUA CONTINUUA IN EACH BAND                              SPDEC3A.133   
     &   , INDEX_WATER                                                             SPDEC3A.134   
!             INDEX OF WATER VAPOUR                                                SPDEC3A.135   
     &   , I_SCALE_FNC_CONT(NPD_BAND, NPD_CONTINUUM)                               SPDEC3A.136   
!             TYPE OF SCALING FUNCTION FOR CONTINUUM                               SPDEC3A.137   
!                                                                                  SPDEC3A.138   
      REAL                                                                         SPDEC3A.139   
     &     K_CONTINUUM(NPD_BAND, NPD_CONTINUUM)                                    SPDEC3A.140   
!             GREY EXTINCTION COEFFICIENTS FOR CONTINUUM                           SPDEC3A.141   
     &   , SCALE_CONTINUUM(NPD_SCALE_VARIABLE, NPD_BAND, NPD_CONTINUUM)            SPDEC3A.142   
!             SCALING PARAMETERS FOR CONTINUUM                                     SPDEC3A.143   
     &   , P_REF_CONTINUUM(NPD_CONTINUUM, NPD_BAND)                                SPDEC3A.144   
!             REFERENCE PRESSURE FOR SCALING OF CONTINUUM                          SPDEC3A.145   
     &   , T_REF_CONTINUUM(NPD_CONTINUUM, NPD_BAND)                                SPDEC3A.146   
!             REFERENCE TEMPERATURE FOR SCALING OF CONTINUUM                       SPDEC3A.147   
!                                                                                  SPDEC3A.148   
!                                                                                  SPDEC3A.149   
!                                                                                  SPDEC3A.150   
!     FIELDS FOR WATER DROPLETS:                                                   SPDEC3A.151   
!                                                                                  SPDEC3A.152   
      INTEGER                                                                      SPDEC3A.153   
     &     I_DROP_PARAMETRIZATION(NPD_DROP_TYPE)                                   SPDEC3A.154   
!             PARAMETRIZATION TYPE OF DROPLETS                                     SPDEC3A.155   
!                                                                                  SPDEC3A.156   
      LOGICAL                                                                      SPDEC3A.157   
     &     L_DROP_TYPE(NPD_DROP_TYPE)                                              SPDEC3A.158   
!             TYPES OF DROPLET PRESENT                                             SPDEC3A.159   
!                                                                                  SPDEC3A.160   
      REAL                                                                         SPDEC3A.161   
     &     DROP_PARAMETER_LIST(NPD_CLOUD_PARAMETER                                 SPDEC3A.162   
     &        , NPD_BAND, NPD_DROP_TYPE)                                           SPDEC3A.163   
!             PARAMETERS USED TO FIT OPTICAL PROPERTIES OF CLOUDS                  SPDEC3A.164   
     &   , DROP_PARM_MIN_DIM(NPD_DROP_TYPE)                                        SPDEC3A.165   
!             MINIMUM DIMENSION PERMISSIBLE IN THE PARAMETRIZATION                 SPDEC3A.166   
     &   , DROP_PARM_MAX_DIM(NPD_DROP_TYPE)                                        SPDEC3A.167   
!             MAXIMUM DIMENSION PERMISSIBLE IN THE PARAMETRIZATION                 SPDEC3A.168   
!                                                                                  SPDEC3A.169   
!                                                                                  SPDEC3A.170   
!                                                                                  SPDEC3A.171   
!     FIELDS FOR AEROSOLS:                                                         SPDEC3A.172   
!                                                                                  SPDEC3A.173   
      INTEGER                                                                      SPDEC3A.174   
     &     N_AEROSOL                                                               SPDEC3A.175   
!             NUMBER OF SPECIES OF AEROSOL                                         SPDEC3A.176   
     &   , TYPE_AEROSOL(NPD_AEROSOL_SPECIES)                                       SPDEC3A.177   
!             TYPES OF AEROSOLS                                                    SPDEC3A.178   
     &   , I_AEROSOL_PARAMETRIZATION(NPD_AEROSOL_SPECIES)                          SPDEC3A.179   
!             PARAMETRIZATION OF AEROSOLS                                          SPDEC3A.180   
     &   , NHUMIDITY(NPD_AEROSOL_SPECIES)                                          SPDEC3A.181   
!             NUMBERS OF HUMIDITIES                                                SPDEC3A.182   
!                                                                                  SPDEC3A.183   
      LOGICAL                                                                      SPDEC3A.184   
     &     L_AEROSOL_SPECIES(NPD_AEROSOL_SPECIES)                                  SPDEC3A.185   
!             AEROSOL SPECIES INCLUDED                                             SPDEC3A.186   
!                                                                                  SPDEC3A.187   
      REAL                                                                         SPDEC3A.188   
     &     AEROSOL_ABSORPTION(NPD_HUMIDITIES, NPD_AEROSOL_SPECIES                  SPDEC3A.189   
     &        , NPD_BAND)                                                          SPDEC3A.190   
!             ABSORPTION BY AEROSOLS                                               SPDEC3A.191   
     &   , AEROSOL_SCATTERING(NPD_HUMIDITIES, NPD_AEROSOL_SPECIES                  SPDEC3A.192   
     &        , NPD_BAND)                                                          SPDEC3A.193   
!             SCATTERING BY AEROSOLS                                               SPDEC3A.194   
     &   , AEROSOL_ASYMMETRY(NPD_HUMIDITIES, NPD_AEROSOL_SPECIES                   SPDEC3A.195   
     &        , NPD_BAND)                                                          SPDEC3A.196   
!             ASYMMETRY OF AEROSOLS                                                SPDEC3A.197   
     &   , HUMIDITIES(NPD_HUMIDITIES, NPD_AEROSOL_SPECIES)                         SPDEC3A.198   
!             HUMIDITIES FOR COMPONENTS                                            SPDEC3A.199   
!                                                                                  SPDEC3A.200   
!                                                                                  SPDEC3A.201   
!                                                                                  SPDEC3A.202   
!     FIELDS FOR ICE CRYSTALS:                                                     SPDEC3A.203   
!                                                                                  SPDEC3A.204   
      INTEGER                                                                      SPDEC3A.205   
     &     I_ICE_PARAMETRIZATION(NPD_ICE_TYPE)                                     SPDEC3A.206   
!             TYPES OF PARAMETRIZATION OF ICE CRYSTALS                             SPDEC3A.207   
!                                                                                  SPDEC3A.208   
      LOGICAL                                                                      SPDEC3A.209   
     &     L_ICE_TYPE(NPD_ICE_TYPE)                                                SPDEC3A.210   
!             TYPES OF ICE CRYSTAL PRESENT                                         SPDEC3A.211   
!                                                                                  SPDEC3A.212   
      REAL                                                                         SPDEC3A.213   
     &     ICE_PARAMETER_LIST(NPD_CLOUD_PARAMETER                                  SPDEC3A.214   
     &        , NPD_BAND, NPD_ICE_TYPE)                                            SPDEC3A.215   
!             PARAMETERS USED TO FIT SINGLE SCATTERING OF ICE CRYSTALS             SPDEC3A.216   
     &   , ICE_PARM_MIN_DIM(NPD_ICE_TYPE)                                          SPDEC3A.217   
!             MINIMUM DIMENSION PERMISSIBLE IN THE PARAMETRIZATION                 SPDEC3A.218   
     &   , ICE_PARM_MAX_DIM(NPD_ICE_TYPE)                                          SPDEC3A.219   
!             MAXIMUM DIMENSION PERMISSIBLE IN THE PARAMETRIZATION                 SPDEC3A.220   
!                                                                                  SPDEC3A.221   
!                                                                                  SPDEC3A.222   
!                                                                                  SPDEC3A.223   
!     FIELDS FOR DOPPLER BROADENING:                                               SPDEC3A.224   
!                                                                                  SPDEC3A.225   
      LOGICAL                                                                      SPDEC3A.226   
     &     L_DOPPLER_PRESENT(NPD_SPECIES)                                          SPDEC3A.227   
!             FLAG FOR DOPPLER BROADENING FOR EACH SPECIES                         SPDEC3A.228   
!                                                                                  SPDEC3A.229   
      REAL                                                                         SPDEC3A.230   
     &     DOPPLER_CORRECTION(NPD_SPECIES)                                         SPDEC3A.231   
!             DOPPLER CORRECTION TERMS                                             SPDEC3A.232   
!                                                                                  SPDEC3A.233   
!                                                                                  SPDEC3A.234   
!                                                                                  SPDEC3A.235   
!    ------------------------------------------------------------------            SPDEC3A.236   
!                                                                                  RAD_ALL.22053 
!     AUXILIARY VARIABLES USED TO SELECT PARTS OF THE INITIAL SPECTRUM             RAD_ALL.22054 
      INTEGER   !, INTENT(IN)                                                      RAD_ALL.22055 
     &     N_AEROSOL_RETAIN                                                        RAD_ALL.22056 
!             NUMBER OF AEROSOLS IN THE INITIAL SPECTRUM TO BE USED                RAD_ALL.22057 
!             IN THE CALCULATION                                                   RAD_ALL.22058 
     &   , INDEX_AEROSOL_RETAIN(NPD_AEROSOL_SPECIES)                               RAD_ALL.22059 
!             INDICES OF THE RETAINED AEROSOLS                                     RAD_ALL.22060 
!                                                                                  RAD_ALL.22061 
!                                                                                  RAD_ALL.22062 
!     ------------------------------------------------------------------           RAD_ALL.22063 
!     DECLARATION OF REDUCED SPECTRUM.                                             RAD_ALL.22064 
!     ------------------------------------------------------------------           RAD_ALL.22065 
!                                                                                  RAD_ALL.22066 
!     DIMENSIONS OF REDUCED ARRAY:                                                 RAD_ALL.22067 
!                                                                                  RAD_ALL.22068 
      INTEGER                                                                      RAD_ALL.22069 
     &     NPDR_BAND                                                               RAD_ALL.22070 
!             NUMBER OF SPECTRAL BANDS                                             RAD_ALL.22071 
     &   , NPDR_EXCLUDE                                                            RAD_ALL.22072 
!             NUMER OF EXCLUDED BANDS                                              RAD_ALL.22073 
     &   , NPDR_ESFT_TERM                                                          RAD_ALL.22074 
!             NUMBER OF ESFT TERMS                                                 RAD_ALL.22075 
     &   , NPDR_TYPE                                                               RAD_ALL.22076 
!             NUMBER OF DATA TYPES                                                 RAD_ALL.22077 
     &   , NPDR_SPECIES                                                            RAD_ALL.22078 
!             NUMBER OF GASEOUS SPECIES                                            RAD_ALL.22079 
     &   , NPDR_SCALE_FNC                                                          RAD_ALL.22080 
!             NUMBER OF SCALING FUNCTIONS                                          RAD_ALL.22081 
     &   , NPDR_SCALE_VARIABLE                                                     RAD_ALL.22082 
!             NUMBER OF SCALING VARIABLES                                          RAD_ALL.22083 
     &   , NPDR_SURFACE                                                            RAD_ALL.22084 
!             NUMBER OF SURFACE TYPES                                              RAD_ALL.22085 
     &   , NPDR_ALBEDO_PARM                                                        RAD_ALL.22086 
!             NUMBER OF ALBEDO PARAMETERS                                          RAD_ALL.22087 
     &   , NPDR_CONTINUUM                                                          RAD_ALL.22088 
!             NUMBER OF CONTINUA                                                   RAD_ALL.22089 
     &   , NPDR_DROP_TYPE                                                          RAD_ALL.22090 
!             NUMBER OF DROP TYPES                                                 RAD_ALL.22091 
     &   , NPDR_ICE_TYPE                                                           RAD_ALL.22092 
!             NUMBER OF ICE CRYSTAL TYPES                                          RAD_ALL.22093 
     &   , NPDR_AEROSOL_SPECIES                                                    RAD_ALL.22094 
!             NUMBER OF AEROSOL SPECIES                                            RAD_ALL.22095 
     &   , NPDR_THERMAL_COEFF                                                      RAD_ALL.22096 
!             NUMBER OF THERMAL COEFFICIENTS                                       RAD_ALL.22097 
     &   , NPDR_CLOUD_PARAMETER                                                    RAD_ALL.22098 
!             MAX NUMBER OF CLOUD PARAMETERS                                       RAD_ALL.22099 
     &   , NPDR_HUMIDITIES                                                         RAD_ALL.22100 
!             MAXIMUM NUMBER OF HUMIDITIES                                         RAD_ALL.22101 
!                                                                                  RAD_ALL.22102 
!                                                                                  RAD_ALL.22103 
!                                                                                  RAD_ALL.22104 
!     GENERAL FIELDS:                                                              RAD_ALL.22105 
!                                                                                  RAD_ALL.22106 
      LOGICAL                                                                      RAD_ALL.22107 
     &     L_PRESENT_RD(0: NPDR_TYPE)                                              RAD_ALL.22108 
!             FLAG FOR TYPES OF DATA PRESENT                                       RAD_ALL.22109 
!                                                                                  RAD_ALL.22110 
!                                                                                  RAD_ALL.22111 
!                                                                                  RAD_ALL.22112 
!     PROPERTIES OF THE SPECTRAL BANDS:                                            RAD_ALL.22113 
!                                                                                  RAD_ALL.22114 
      INTEGER                                                                      RAD_ALL.22115 
     &     N_BAND_RD                                                               RAD_ALL.22116 
!             NUMBER OF SPECTRAL BANDS                                             RAD_ALL.22117 
!                                                                                  RAD_ALL.22118 
      REAL                                                                         RAD_ALL.22119 
     &     WAVE_LENGTH_SHORT_RD(NPDR_BAND)                                         RAD_ALL.22120 
!             SHORTER WAVELENGTH LIMITS                                            RAD_ALL.22121 
     &   , WAVE_LENGTH_LONG_RD(NPDR_BAND)                                          RAD_ALL.22122 
!             LONGER WAVELENGTH LIMITS                                             RAD_ALL.22123 
!                                                                                  RAD_ALL.22124 
!                                                                                  RAD_ALL.22125 
!                                                                                  RAD_ALL.22126 
!     EXCLUSION OF SPECIFIC BANDS FROM PARTS OF THE SPECTRUM:                      RAD_ALL.22127 
      INTEGER                                                                      RAD_ALL.22128 
     &     N_BAND_EXCLUDE_RD(NPDR_BAND)                                            RAD_ALL.22129 
!             NUMBER OF EXCLUDED BANDS WITHIN EACH SPECTRAL BAND                   RAD_ALL.22130 
     &   , INDEX_EXCLUDE_RD(NPDR_EXCLUDE, NPDR_BAND)                               RAD_ALL.22131 
!             INDICES OF EXCLUDED BANDS                                            RAD_ALL.22132 
!                                                                                  RAD_ALL.22133 
!                                                                                  RAD_ALL.22134 
!                                                                                  RAD_ALL.22135 
!     FIELDS FOR THE SOLAR FLUX:                                                   RAD_ALL.22136 
!                                                                                  RAD_ALL.22137 
      REAL                                                                         RAD_ALL.22138 
     &     SOLAR_FLUX_BAND_RD(NPDR_BAND)                                           RAD_ALL.22139 
!             FRACTION OF THE INCIDENT SOLAR FLUX IN EACH BAND                     RAD_ALL.22140 
!                                                                                  RAD_ALL.22141 
!                                                                                  RAD_ALL.22142 
!                                                                                  RAD_ALL.22143 
!     FIELDS FOR RAYLEIGH SCATTERING:                                              RAD_ALL.22144 
!                                                                                  RAD_ALL.22145 
      REAL                                                                         RAD_ALL.22146 
     &     RAYLEIGH_COEFFICIENT_RD(NPDR_BAND)                                      RAD_ALL.22147 
!             RAYLEIGH COEFFICIENTS                                                RAD_ALL.22148 
!                                                                                  RAD_ALL.22149 
!                                                                                  RAD_ALL.22150 
!                                                                                  RAD_ALL.22151 
!     FIELDS FOR GASEOUS ABSORPTION:                                               RAD_ALL.22152 
!                                                                                  RAD_ALL.22153 
      INTEGER                                                                      RAD_ALL.22154 
     &     N_ABSORB_RD                                                             RAD_ALL.22155 
!             NUMBER OF ABSORBERS                                                  RAD_ALL.22156 
     &   , N_BAND_ABSORB_RD(NPDR_BAND)                                             RAD_ALL.22157 
!             NUMBER OF ABSORBERS IN EACH BAND                                     RAD_ALL.22158 
     &   , INDEX_ABSORB_RD(NPDR_SPECIES, NPDR_BAND)                                RAD_ALL.22159 
!             LIST OF ABSORBERS IN EACH BAND                                       RAD_ALL.22160 
     &   , TYPE_ABSORB_RD(NPDR_SPECIES)                                            RAD_ALL.22161 
!             TYPES OF EACH GAS IN THE SPECTRAL FILE                               RAD_ALL.22162 
     &   , I_BAND_ESFT_RD(NPDR_BAND, NPDR_SPECIES)                                 RAD_ALL.22163 
!             NUMBER OF ESFT TERMS IN BAND FOR EACH GAS                            RAD_ALL.22164 
     &   , I_SCALE_ESFT_RD(NPDR_BAND, NPDR_SPECIES)                                RAD_ALL.22165 
!             TYPE OF ESFT SCALING                                                 RAD_ALL.22166 
     &   , I_SCALE_FNC_RD(NPDR_BAND, NPDR_SPECIES)                                 RAD_ALL.22167 
!             TYPE OF SCALING FUNCTION                                             RAD_ALL.22168 
!                                                                                  RAD_ALL.22169 
      REAL                                                                         RAD_ALL.22170 
     &     K_ESFT_RD(NPDR_ESFT_TERM, NPDR_BAND, NPDR_SPECIES)                      RAD_ALL.22171 
!             ESFT EXPONENTS                                                       RAD_ALL.22172 
     &   , W_ESFT_RD(NPDR_ESFT_TERM, NPDR_BAND, NPDR_SPECIES)                      RAD_ALL.22173 
!             ESFT WEIGHTS                                                         RAD_ALL.22174 
     &   , SCALE_VECTOR_RD(NPDR_SCALE_VARIABLE, NPDR_ESFT_TERM                     RAD_ALL.22175 
     &        , NPDR_BAND, NPDR_SPECIES)                                           RAD_ALL.22176 
!             SCALING PARAMETERS FOR EACH ABSORBER AND TERM                        RAD_ALL.22177 
     &   , P_REFERENCE_RD(NPDR_SPECIES, NPDR_BAND)                                 RAD_ALL.22178 
!             REFERENCE PRESSURE FOR SCALING FUNCTION                              RAD_ALL.22179 
     &   , T_REFERENCE_RD(NPDR_SPECIES, NPDR_BAND)                                 RAD_ALL.22180 
!             REFERENCE TEMPERATURE FOR SCALING FUNCTION                           RAD_ALL.22181 
!                                                                                  RAD_ALL.22182 
!                                                                                  RAD_ALL.22183 
!                                                                                  RAD_ALL.22184 
!     REPRESENTATION OF THE PLANCKIAN:                                             RAD_ALL.22185 
!                                                                                  RAD_ALL.22186 
      INTEGER                                                                      RAD_ALL.22187 
     &     N_DEG_FIT_RD                                                            RAD_ALL.22188 
!             DEGREE OF THERMAL POLYNOMIAL                                         RAD_ALL.22189 
!                                                                                  RAD_ALL.22190 
      REAL                                                                         RAD_ALL.22191 
     &     THERMAL_COEFFICIENT_RD(0: NPDR_THERMAL_COEFF-1, NPDR_BAND)              RAD_ALL.22192 
!             COEFFICIENTS IN POLYNOMIAL FIT TO SOURCE FUNCTION                    RAD_ALL.22193 
     &   , T_REF_PLANCK_RD                                                         RAD_ALL.22194 
!             PLANCKIAN REFERENCE TEMPERATURE                                      RAD_ALL.22195 
!                                                                                  RAD_ALL.22196 
!                                                                                  RAD_ALL.22197 
!                                                                                  RAD_ALL.22198 
!     SURFACE PROPERTIES:                                                          RAD_ALL.22199 
!                                                                                  RAD_ALL.22200 
      INTEGER                                                                      RAD_ALL.22201 
     &     I_SPEC_SURFACE_RD(NPDR_SURFACE)                                         RAD_ALL.22202 
!             METHOD OF SPECIFYING PROPERTIES OF SURFACE                           RAD_ALL.22203 
     &   , N_DIR_ALBEDO_FIT_RD(NPDR_SURFACE)                                       RAD_ALL.22204 
!             NUMBER OF PARAMETERS FITTING THE DIRECT ALBEDO                       RAD_ALL.22205 
!                                                                                  RAD_ALL.22206 
      LOGICAL                                                                      RAD_ALL.22207 
     &     L_SURFACE_RD(NPDR_SURFACE)                                              RAD_ALL.22208 
!             SURFACE TYPES INCLUDED                                               RAD_ALL.22209 
!                                                                                  RAD_ALL.22210 
      REAL                                                                         RAD_ALL.22211 
     &     SURFACE_ALBEDO_RD(NPDR_BAND, NPDR_SURFACE)                              RAD_ALL.22212 
!             SURFACE ALBEDOS                                                      RAD_ALL.22213 
     &   , DIRECT_ALBEDO_PARM_RD(0: NPDR_ALBEDO_PARM                               RAD_ALL.22214 
     &        , NPD_BAND, NPD_SURFACE)                                             RAD_ALL.22215 
!             COEFFICIENTS FOR FITTING DIRECT ALBEDO                               RAD_ALL.22216 
     &   , EMISSIVITY_GROUND_RD(NPDR_BAND, NPDR_SURFACE)                           RAD_ALL.22217 
!             SURFACE EMISSIVITIES                                                 RAD_ALL.22218 
!                                                                                  RAD_ALL.22219 
!                                                                                  RAD_ALL.22220 
!                                                                                  RAD_ALL.22221 
!     FIELDS FOR CONTINUA:                                                         RAD_ALL.22222 
!                                                                                  RAD_ALL.22223 
      INTEGER                                                                      RAD_ALL.22224 
     &     N_BAND_CONTINUUM_RD(NPDR_BAND)                                          RAD_ALL.22225 
!             NUMBER OF CONTINUA IN EACH BAND                                      RAD_ALL.22226 
     &   , INDEX_CONTINUUM_RD(NPDR_BAND, NPDR_CONTINUUM)                           RAD_ALL.22227 
!             LIST OF CONTINUA IN EACH BAND                                        RAD_ALL.22228 
     &   , INDEX_WATER_RD                                                          RAD_ALL.22229 
!             INDEX OF WATER VAPOUR                                                RAD_ALL.22230 
     &   , I_SCALE_FNC_CONT_RD(NPDR_BAND, NPDR_CONTINUUM)                          RAD_ALL.22231 
!             TYPE OF SCALING FUNCTION FOR CONTINUUM                               RAD_ALL.22232 
!                                                                                  RAD_ALL.22233 
      REAL                                                                         RAD_ALL.22234 
     &     K_CONTINUUM_RD(NPDR_BAND, NPDR_CONTINUUM)                               RAD_ALL.22235 
!             GREY EXTINCTION COEFFICIENTS FOR CONTINUUM                           RAD_ALL.22236 
     &   , SCALE_CONTINUUM_RD(NPDR_SCALE_VARIABLE                                  RAD_ALL.22237 
     &        , NPDR_BAND, NPDR_CONTINUUM)                                         RAD_ALL.22238 
!             SCALING PARAMETERS FOR CONTINUUM                                     RAD_ALL.22239 
     &   , P_REF_CONTINUUM_RD(NPDR_CONTINUUM, NPDR_BAND)                           RAD_ALL.22240 
!             REFERENCE PRESSURE FOR SCALING OF CONTINUUM                          RAD_ALL.22241 
     &   , T_REF_CONTINUUM_RD(NPDR_CONTINUUM, NPDR_BAND)                           RAD_ALL.22242 
!             REFERENCE TEMPERATURE FOR SCALING OF CONTINUUM                       RAD_ALL.22243 
!                                                                                  RAD_ALL.22244 
!                                                                                  RAD_ALL.22245 
!                                                                                  RAD_ALL.22246 
!     FIELDS FOR WATER DROPLETS:                                                   RAD_ALL.22247 
!                                                                                  RAD_ALL.22248 
      INTEGER                                                                      RAD_ALL.22249 
     &     I_DROP_PARAMETRIZATION_RD(NPDR_DROP_TYPE)                               RAD_ALL.22250 
!             PARAMETRIZATION TYPE OF DROPLETS                                     RAD_ALL.22251 
!                                                                                  RAD_ALL.22252 
      LOGICAL                                                                      RAD_ALL.22253 
     &     L_DROP_TYPE_RD(NPDR_DROP_TYPE)                                          RAD_ALL.22254 
!             TYPES OF DROPLET PRESENT                                             RAD_ALL.22255 
!                                                                                  RAD_ALL.22256 
      REAL                                                                         RAD_ALL.22257 
     &     DROP_PARAMETER_LIST_RD(NPDR_CLOUD_PARAMETER                             RAD_ALL.22258 
     &        , NPDR_BAND, NPDR_DROP_TYPE)                                         RAD_ALL.22259 
!             PARAMETERS USED TO FIT OPTICAL PROPERTIES OF CLOUDS                  RAD_ALL.22260 
     &   , DROP_PARM_MIN_DIM_RD(NPDR_DROP_TYPE)                                    RAD_ALL.22261 
!             MINIMUM SIZE OF DROPLET PERMITTED IN THE PARAMETRIZATION             RAD_ALL.22262 
     &   , DROP_PARM_MAX_DIM_RD(NPDR_DROP_TYPE)                                    RAD_ALL.22263 
!             MAXIMUM SIZE OF DROPLET PERMITTED IN THE PARAMETRIZATION             RAD_ALL.22264 
!                                                                                  RAD_ALL.22265 
!                                                                                  RAD_ALL.22266 
!                                                                                  RAD_ALL.22267 
!     FIELDS FOR AEROSOLS:                                                         RAD_ALL.22268 
!                                                                                  RAD_ALL.22269 
      INTEGER                                                                      RAD_ALL.22270 
     &     N_AEROSOL_RD                                                            RAD_ALL.22271 
!             NUMBER OF SPECIES OF AEROSOL                                         RAD_ALL.22272 
     &   , TYPE_AEROSOL_RD(NPDR_AEROSOL_SPECIES)                                   RAD_ALL.22273 
!             TYPES OF AEROSOLS                                                    RAD_ALL.22274 
     &   , I_AEROSOL_PARAMETRIZATION_RD(NPDR_AEROSOL_SPECIES)                      RAD_ALL.22275 
!             PARAMETRIZATION OF AEROSOLS                                          RAD_ALL.22276 
     &   , NHUMIDITY_RD(NPDR_AEROSOL_SPECIES)                                      RAD_ALL.22277 
!             NUMBERS OF HUMIDITIES                                                RAD_ALL.22278 
!                                                                                  RAD_ALL.22279 
      LOGICAL                                                                      RAD_ALL.22280 
     &     L_AEROSOL_SPECIES_RD(NPDR_AEROSOL_SPECIES)                              RAD_ALL.22281 
!             AEROSOL SPECIES INCLUDED                                             RAD_ALL.22282 
!                                                                                  RAD_ALL.22283 
      REAL                                                                         RAD_ALL.22284 
     &     AEROSOL_ABSORPTION_RD(NPDR_HUMIDITIES, NPDR_AEROSOL_SPECIES             RAD_ALL.22285 
     &        , NPDR_BAND)                                                         RAD_ALL.22286 
!             ABSORPTION BY AEROSOLS                                               RAD_ALL.22287 
     &   , AEROSOL_SCATTERING_RD(NPDR_HUMIDITIES, NPDR_AEROSOL_SPECIES             RAD_ALL.22288 
     &        , NPDR_BAND)                                                         RAD_ALL.22289 
!             SCATTERING BY AEROSOLS                                               RAD_ALL.22290 
     &   , AEROSOL_ASYMMETRY_RD(NPDR_HUMIDITIES, NPDR_AEROSOL_SPECIES              RAD_ALL.22291 
     &        , NPDR_BAND)                                                         RAD_ALL.22292 
!             ASYMMETRY OF AEROSOLS                                                RAD_ALL.22293 
     &   , HUMIDITIES_RD(NPDR_HUMIDITIES, NPDR_AEROSOL_SPECIES)                    RAD_ALL.22294 
!             HUMIDITIES FOR COMPONENTS                                            RAD_ALL.22295 
!                                                                                  RAD_ALL.22296 
!                                                                                  RAD_ALL.22297 
!                                                                                  RAD_ALL.22298 
!     FIELDS FOR ICE CRYSTALS:                                                     RAD_ALL.22299 
!                                                                                  RAD_ALL.22300 
      INTEGER                                                                      RAD_ALL.22301 
     &     I_ICE_PARAMETRIZATION_RD(NPDR_ICE_TYPE)                                 RAD_ALL.22302 
!             TYPES OF PARAMETRIZATION OF ICE CRYSTALS                             RAD_ALL.22303 
!                                                                                  RAD_ALL.22304 
      LOGICAL                                                                      RAD_ALL.22305 
     &     L_ICE_TYPE_RD(NPDR_ICE_TYPE)                                            RAD_ALL.22306 
!             TYPES OF ICE CRYSTAL PRESENT                                         RAD_ALL.22307 
!                                                                                  RAD_ALL.22308 
      REAL                                                                         RAD_ALL.22309 
     &     ICE_PARAMETER_LIST_RD(NPDR_CLOUD_PARAMETER                              RAD_ALL.22310 
     &        , NPDR_BAND, NPDR_ICE_TYPE)                                          RAD_ALL.22311 
!             PARAMETERS USED TO FIT SINGLE SCATTERING OF ICE CRYSTALS             RAD_ALL.22312 
     &   , ICE_PARM_MIN_DIM_RD(NPDR_ICE_TYPE)                                      RAD_ALL.22313 
!             MINIMUM SIZE OF ICE CRYSTAL PERMITTED                                RAD_ALL.22314 
!             IN THE PARAMETRIZATION                                               RAD_ALL.22315 
     &   , ICE_PARM_MAX_DIM_RD(NPDR_ICE_TYPE)                                      RAD_ALL.22316 
!             MAXIMUM SIZE OF ICE CRYSTAL PERMITTED                                RAD_ALL.22317 
!             IN THE PARAMETRIZATION                                               RAD_ALL.22318 
!                                                                                  RAD_ALL.22319 
!                                                                                  RAD_ALL.22320 
!                                                                                  RAD_ALL.22321 
!     FIELDS FOR DOPPLER BROADENING:                                               RAD_ALL.22322 
!                                                                                  RAD_ALL.22323 
      LOGICAL                                                                      RAD_ALL.22324 
     &     L_DOPPLER_PRESENT_RD(NPDR_SPECIES)                                      RAD_ALL.22325 
!             FLAG FOR DOPPLER BROADENING FOR EACH SPECIES                         RAD_ALL.22326 
!                                                                                  RAD_ALL.22327 
      REAL                                                                         RAD_ALL.22328 
     &     DOPPLER_CORRECTION_RD(NPDR_SPECIES)                                     RAD_ALL.22329 
!             DOPPLER CORRECTION TERMS                                             RAD_ALL.22330 
!                                                                                  RAD_ALL.22331 
!                                                                                  RAD_ALL.22332 
!                                                                                  RAD_ALL.22333 
!     LOCAL VARIABLES.                                                             RAD_ALL.22334 
      INTEGER                                                                      RAD_ALL.22335 
     &     I                                                                       RAD_ALL.22336 
!             LOOP VARIABLE                                                        RAD_ALL.22337 
     &   , J                                                                       RAD_ALL.22338 
!             LOOP VARIABLE                                                        RAD_ALL.22339 
     &   , K                                                                       RAD_ALL.22340 
!             LOOP VARIABLE                                                        RAD_ALL.22341 
     &   , L                                                                       RAD_ALL.22342 
!             LOOP VARIABLE                                                        RAD_ALL.22343 
     &   , N_PARAMETER                                                             RAD_ALL.22344 
!             NUMBER OF PARAMETERS IN SCHEME.                                      RAD_ALL.22345 
     &   , I_SPECIES                                                               RAD_ALL.22346 
!             SPECIES OF GAS                                                       RAD_ALL.22347 
     &   , I_CONTINUUM                                                             RAD_ALL.22348 
!             TYPE OF CONTINUUM                                                    RAD_ALL.22349 
     &   , I_INITIAL                                                               RAD_ALL.22350 
!             INDEXING NUMBER IN INITIAL SPECTRAL FILE                             RAD_ALL.22351 
!                                                                                  RAD_ALL.22352 
!                                                                                  RAD_ALL.22353 
!     ------------------------------------------------------------------           SCLFNC3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       SCLFNC3A.3     
!                                                                                  SCLFNC3A.4     
!     MODULE TO SET TYPES OF SCALING FOR ABSORBER AMOUNTS                          SCLFNC3A.5     
!                                                                                  SCLFNC3A.6     
      INTEGER                                                                      SCLFNC3A.7     
     &     IP_SCALE_FNC_NULL                                                       SCLFNC3A.8     
!             NULL SCALING FUNCTION                                                SCLFNC3A.9     
     &   , IP_SCALE_POWER_LAW                                                      SCLFNC3A.10    
!             POWER LAW SCALING FUNCTION                                           SCLFNC3A.11    
     &   , IP_SCALE_POWER_QUAD                                                     SCLFNC3A.12    
!             POWER LAW FOR P; QUADRATIC FOR T                                     SCLFNC3A.13    
     &   , IP_SCALE_DOPPLER_QUAD                                                   SCLFNC3A.14    
!             POWER LAW FOR P; QUADRATIC FOR T                                     SCLFNC3A.15    
!              WITH IMPLICIT DOPPLER CORRECTION                                    SCLFNC3A.16    
     &   , N_SCALE_VARIABLE(0: NPD_SCALE_FNC)                                      SCLFNC3A.17    
!             NUMBER OF SCALING VARIABLES                                          SCLFNC3A.18    
!                                                                                  SCLFNC3A.19    
      PARAMETER(                                                                   SCLFNC3A.20    
     &     IP_SCALE_FNC_NULL=0                                                     SCLFNC3A.21    
     &   , IP_SCALE_POWER_LAW=1                                                    SCLFNC3A.22    
     &   , IP_SCALE_POWER_QUAD=2                                                   SCLFNC3A.23    
     &   , IP_SCALE_DOPPLER_QUAD=3                                                 SCLFNC3A.24    
     &   )                                                                         SCLFNC3A.25    
!                                                                                  SCLFNC3A.26    
!     -----------------------------------------------------------------            SCLFNC3A.27    
!     ------------------------------------------------------------------           WCLPRM3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       WCLPRM3A.3     
!                                                                                  WCLPRM3A.4     
!     MODULE TO SET NUMBERS FOR WATER CLOUD SCHEMES.                               WCLPRM3A.5     
!                                                                                  WCLPRM3A.6     
      INTEGER                                                                      WCLPRM3A.7     
     &     NPD_CLOUD_FIT                                                           WCLPRM3A.8     
!             NUMBER OF CLOUD FITTING SCHEMES                                      WCLPRM3A.9     
     &   , IP_SLINGO_SCHRECKER                                                     WCLPRM3A.10    
!             PARAMETRIZATION OF SLINGO-SCHRECKER                                  WCLPRM3A.11    
     &   , IP_ACKERMAN_STEPHENS                                                    WCLPRM3A.12    
!             PARAMETRIZATION OF ACKERMAN & STEPHENS                               WCLPRM3A.13    
     &   , IP_DROP_UNPARAMETRIZED                                                  WCLPRM3A.14    
!             UNPARAMETRIZED DROPLET DATA                                          WCLPRM3A.15    
!                                                                                  WCLPRM3A.16    
      PARAMETER(                                                                   WCLPRM3A.17    
     &     NPD_CLOUD_FIT=3                                                         WCLPRM3A.18    
     &   , IP_SLINGO_SCHRECKER=1                                                   WCLPRM3A.19    
     &   , IP_ACKERMAN_STEPHENS=2                                                  WCLPRM3A.20    
     &   , IP_DROP_UNPARAMETRIZED=3                                                WCLPRM3A.21    
     &   )                                                                         WCLPRM3A.22    
!                                                                                  WCLPRM3A.23    
!     ------------------------------------------------------------------           WCLPRM3A.24    
!     ------------------------------------------------------------------           ICLPRM3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       ICLPRM3A.3     
!                                                                                  ICLPRM3A.4     
!     MODULE TO SET NUMBERS FOR ICE CLOUD SCHEMES.                                 ICLPRM3A.5     
!                                                                                  ICLPRM3A.6     
      INTEGER                                                                      ICLPRM3A.7     
     &     NPD_ICE_CLOUD_FIT                                                       ICLPRM3A.8     
!             NUMBER OF CLOUD FITTING SCHEMES                                      ICLPRM3A.9     
     &   , IP_SLINGO_SCHRECKER_ICE                                                 ICLPRM3A.10    
!             PARAMETRIZATION OF SLINGO AND SCHRECKER.                             ICLPRM3A.11    
     &   , IP_ICE_UNPARAMETRIZED                                                   ICLPRM3A.12    
!             UNPARAMETRIZED ICE CRYSTAL DATA                                      ICLPRM3A.13    
     &   , IP_SUN_SHINE_VN2_VIS                                                    ICLPRM3A.14    
!             SUN AND SHINE'S PARAMETRIZATION IN THE VISIBLE (VERSION 2)           ICLPRM3A.15    
     &   , IP_SUN_SHINE_VN2_IR                                                     ICLPRM3A.16    
!             SUN AND SHINE'S PARAMETRIZATION IN THE IR (VERSION 2)                ICLPRM3A.17    
     &   , IP_ICE_ADT                                                              ICLPRM3A.18    
!             SCHEME BASED ON ANOMALOUS DIFFRACTION THEORY                         ICLPRM3A.19    
!             FOR ICE CRYSTALS                                                     ICLPRM3A.20    
                                                                                   ICLPRM3A.21    
!                                                                                  ICLPRM3A.22    
      PARAMETER(                                                                   ICLPRM3A.23    
     &     NPD_ICE_CLOUD_FIT=6                                                     ICLPRM3A.24    
     &   , IP_SLINGO_SCHRECKER_ICE=1                                               ICLPRM3A.25    
     &   , IP_ICE_UNPARAMETRIZED=3                                                 ICLPRM3A.26    
     &   , IP_SUN_SHINE_VN2_VIS=4                                                  ICLPRM3A.27    
     &   , IP_SUN_SHINE_VN2_IR=5                                                   ICLPRM3A.28    
     &   , IP_ICE_ADT=6                                                            ICLPRM3A.29    
     &   )                                                                         ICLPRM3A.30    
!                                                                                  ICLPRM3A.31    
!     ------------------------------------------------------------------           ICLPRM3A.32    
!     ------------------------------------------------------------------           AERPRM3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       AERPRM3A.3     
!                                                                                  AERPRM3A.4     
!     MODULE TO SET THE AEROSOL PARAMETRIZATIONS.                                  AERPRM3A.5     
!                                                                                  AERPRM3A.6     
      INTEGER                                                                      AERPRM3A.7     
     &     IP_AEROSOL_PARAM_DRY                                                    AERPRM3A.8     
!             PARAMETRIZATION FOR DRY AEROSOLS                                     AERPRM3A.9     
     &   , IP_AEROSOL_PARAM_MOIST                                                  AERPRM3A.10    
!             PARAMETRIZATION FOR MOIST AEROSOLS                                   AERPRM3A.11    
     &   , IP_AEROSOL_UNPARAMETRIZED                                               AERPRM3A.12    
!             OBSERVATIONAL AEROSOL DATA                                           AERPRM3A.13    
!                                                                                  AERPRM3A.14    
      PARAMETER(                                                                   AERPRM3A.15    
     &     IP_AEROSOL_PARAM_DRY=1                                                  AERPRM3A.16    
     &   , IP_AEROSOL_PARAM_MOIST=2                                                AERPRM3A.17    
     &   , IP_AEROSOL_UNPARAMETRIZED=3                                             AERPRM3A.18    
     &   )                                                                         AERPRM3A.19    
!                                                                                  AERPRM3A.20    
!     ------------------------------------------------------------------           AERPRM3A.21    
!     ------------------------------------------------------------------           SCLFND3A.2     
!     COMDECK FOR TWO-STREAM RADIATION CODE.                                       SCLFND3A.3     
!                                                                                  SCLFND3A.4     
!     MODULE TO SET DATA FOR SCALING FUNCTIONS.                                    SCLFND3A.5     
!                                                                                  SCLFND3A.6     
      DATA N_SCALE_VARIABLE(IP_SCALE_POWER_LAW)/2/                                 SCLFND3A.7     
     &  ,  N_SCALE_VARIABLE(IP_SCALE_FNC_NULL)/0/                                  SCLFND3A.8     
     &  ,  N_SCALE_VARIABLE(IP_SCALE_POWER_QUAD)/3/                                SCLFND3A.9     
     &  ,  N_SCALE_VARIABLE(IP_SCALE_DOPPLER_QUAD)/4/                              SCLFND3A.10    
!                                                                                  SCLFND3A.11    
!     ------------------------------------------------------------------           SCLFND3A.12    
!                                                                                  RAD_ALL.22359 
!                                                                                  RAD_ALL.22360 
!                                                                                  RAD_ALL.22361 
!                                                                                  RAD_ALL.22362 
!                                                                                  RAD_ALL.22363 
!     INITAILIZE ALL BLOCKS OF THE COMPRESSED SPECTRUM TO .FALSE.                  RAD_ALL.22364 
      DO I=1, NPDR_TYPE                                                            RAD_ALL.22365 
         L_PRESENT_RD(I)=.FALSE.                                                   RAD_ALL.22366 
      ENDDO                                                                        RAD_ALL.22367 
!                                                                                  RAD_ALL.22368 
!                                                                                  RAD_ALL.22369 
!     PROCEED THROUGH EACH BLOCK OF THE SPECTRAL FILE TRANSFERRING                 RAD_ALL.22370 
!     THE DATA FROM THE INPUT ARRAY TO THE REDUCED ARRAY.                          RAD_ALL.22371 
!                                                                                  RAD_ALL.22372 
!                                                                                  RAD_ALL.22373 
!     BLOCK 0:                                                                     RAD_ALL.22374 
!                                                                                  RAD_ALL.22375 
      IF (L_PRESENT(0)) THEN                                                       RAD_ALL.22376 
         L_PRESENT_RD(0)=.TRUE.                                                    RAD_ALL.22377 
         N_BAND_RD=N_BAND                                                          RAD_ALL.22378 
         N_ABSORB_RD=N_ABSORB                                                      RAD_ALL.22379 
         N_AEROSOL_RD=N_AEROSOL_RETAIN                                             RAD_ALL.22380 
         DO I=1, N_ABSORB                                                          RAD_ALL.22381 
            TYPE_ABSORB_RD(I)=TYPE_ABSORB(I)                                       RAD_ALL.22382 
         ENDDO                                                                     RAD_ALL.22383 
         DO I=1, N_AEROSOL_RETAIN                                                  RAD_ALL.22384 
            TYPE_AEROSOL_RD(I)=TYPE_AEROSOL(INDEX_AEROSOL_RETAIN(I))               RAD_ALL.22385 
         ENDDO                                                                     RAD_ALL.22386 
      ENDIF                                                                        RAD_ALL.22387 
!                                                                                  RAD_ALL.22388 
!     BLOCK 1:                                                                     RAD_ALL.22389 
      IF (L_PRESENT(1)) THEN                                                       RAD_ALL.22390 
         L_PRESENT_RD(1)=.TRUE.                                                    RAD_ALL.22391 
         DO I=1, N_BAND                                                            RAD_ALL.22392 
            WAVE_LENGTH_SHORT_RD(I)=WAVE_LENGTH_SHORT(I)                           RAD_ALL.22393 
            WAVE_LENGTH_LONG_RD(I)=WAVE_LENGTH_LONG(I)                             RAD_ALL.22394 
         ENDDO                                                                     RAD_ALL.22395 
      ENDIF                                                                        RAD_ALL.22396 
!                                                                                  RAD_ALL.22397 
!     BLOCK 2:                                                                     RAD_ALL.22398 
      IF (L_PRESENT(2)) THEN                                                       RAD_ALL.22399 
         L_PRESENT_RD(2)=.TRUE.                                                    RAD_ALL.22400 
         DO I=1, N_BAND                                                            RAD_ALL.22401 
            SOLAR_FLUX_BAND_RD(I)=SOLAR_FLUX_BAND(I)                               RAD_ALL.22402 
         ENDDO                                                                     RAD_ALL.22403 
      ENDIF                                                                        RAD_ALL.22404 
!                                                                                  RAD_ALL.22405 
!     BLOCK 3:                                                                     RAD_ALL.22406 
      IF (L_PRESENT(3)) THEN                                                       RAD_ALL.22407 
         L_PRESENT_RD(3)=.TRUE.                                                    RAD_ALL.22408 
         DO I=1, N_BAND                                                            RAD_ALL.22409 
            RAYLEIGH_COEFFICIENT_RD(I)=RAYLEIGH_COEFFICIENT(I)                     RAD_ALL.22410 
         ENDDO                                                                     RAD_ALL.22411 
      ENDIF                                                                        RAD_ALL.22412 
!                                                                                  RAD_ALL.22413 
!     BLOCK 4:                                                                     RAD_ALL.22414 
      IF (L_PRESENT(4)) THEN                                                       RAD_ALL.22415 
         L_PRESENT_RD(4)=.TRUE.                                                    RAD_ALL.22416 
         DO I=1, N_BAND                                                            RAD_ALL.22417 
            N_BAND_ABSORB_RD(I)=N_BAND_ABSORB(I)                                   RAD_ALL.22418 
            DO J=1, N_BAND_ABSORB(I)                                               RAD_ALL.22419 
               INDEX_ABSORB_RD(J, I)=INDEX_ABSORB(J, I)                            RAD_ALL.22420 
            ENDDO                                                                  RAD_ALL.22421 
         ENDDO                                                                     RAD_ALL.22422 
      ENDIF                                                                        RAD_ALL.22423 
!                                                                                  RAD_ALL.22424 
!     BLOCK 5:                                                                     RAD_ALL.22425 
      IF (L_PRESENT(5)) THEN                                                       RAD_ALL.22426 
         L_PRESENT_RD(5)=.TRUE.                                                    RAD_ALL.22427 
         DO I=1, N_BAND                                                            RAD_ALL.22428 
            DO J=1, N_BAND_ABSORB(I)                                               RAD_ALL.22429 
               I_SPECIES=INDEX_ABSORB_RD(J, I)                                     RAD_ALL.22430 
               I_BAND_ESFT_RD(I, I_SPECIES)=I_BAND_ESFT(I, I_SPECIES)              RAD_ALL.22431 
               I_SCALE_ESFT_RD(I, I_SPECIES)=I_SCALE_ESFT(I, I_SPECIES)            RAD_ALL.22432 
               I_SCALE_FNC_RD(I, I_SPECIES)=I_SCALE_FNC(I, I_SPECIES)              RAD_ALL.22433 
               P_REFERENCE_RD(I_SPECIES, I)=P_REFERENCE(I_SPECIES, I)              RAD_ALL.22434 
               T_REFERENCE_RD(I_SPECIES, I)=T_REFERENCE(I_SPECIES, I)              RAD_ALL.22435 
               DO K=1, I_BAND_ESFT(I, I_SPECIES)                                   RAD_ALL.22436 
                  K_ESFT_RD(K, I, I_SPECIES)=K_ESFT(K, I, I_SPECIES)               RAD_ALL.22437 
                  W_ESFT_RD(K, I, I_SPECIES)=W_ESFT(K, I, I_SPECIES)               RAD_ALL.22438 
                  DO L=1, N_SCALE_VARIABLE(I_SCALE_FNC(I, I_SPECIES))              RAD_ALL.22439 
                     SCALE_VECTOR_RD(L, K, I, I_SPECIES)                           RAD_ALL.22440 
     &                  =SCALE_VECTOR(L, K, I, I_SPECIES)                          RAD_ALL.22441 
                  ENDDO                                                            RAD_ALL.22442 
               ENDDO                                                               RAD_ALL.22443 
            ENDDO                                                                  RAD_ALL.22444 
         ENDDO                                                                     RAD_ALL.22445 
      ENDIF                                                                        RAD_ALL.22446 
!                                                                                  RAD_ALL.22447 
!     BLOCK 6:                                                                     RAD_ALL.22448 
      IF (L_PRESENT(6)) THEN                                                       RAD_ALL.22449 
         L_PRESENT_RD(6)=.TRUE.                                                    RAD_ALL.22450 
         N_DEG_FIT_RD=N_DEG_FIT                                                    RAD_ALL.22451 
         T_REF_PLANCK_RD=T_REF_PLANCK                                              RAD_ALL.22452 
         DO I=1, N_BAND                                                            RAD_ALL.22453 
            DO J=0, N_DEG_FIT                                                      RAD_ALL.22454 
               THERMAL_COEFFICIENT_RD(J, I)=THERMAL_COEFFICIENT(J, I)              RAD_ALL.22455 
            ENDDO                                                                  RAD_ALL.22456 
         ENDDO                                                                     RAD_ALL.22457 
      ENDIF                                                                        RAD_ALL.22458 
!                                                                                  RAD_ALL.22459 
!     BLOCK 7:                                                                     RAD_ALL.22460 
!                                                                                  RAD_ALL.22461 
!     OMITTED SINCE SURFACE ALBEDOS ARE PROVIDED BY THE MODEL.                     RAD_ALL.22462 
!                                                                                  RAD_ALL.22463 
!     BLOCK 8:                                                                     RAD_ALL.22464 
      IF (L_PRESENT(8)) THEN                                                       RAD_ALL.22465 
         L_PRESENT_RD(8)=.TRUE.                                                    RAD_ALL.22466 
         DO I=1, N_BAND                                                            RAD_ALL.22467 
            N_BAND_CONTINUUM_RD(I)=N_BAND_CONTINUUM(I)                             RAD_ALL.22468 
            DO J=1, N_BAND_CONTINUUM(I)                                            RAD_ALL.22469 
               INDEX_CONTINUUM_RD(I, J)=INDEX_CONTINUUM(I, J)                      RAD_ALL.22470 
            ENDDO                                                                  RAD_ALL.22471 
         ENDDO                                                                     RAD_ALL.22472 
         INDEX_WATER_RD=INDEX_WATER                                                RAD_ALL.22473 
      ENDIF                                                                        RAD_ALL.22474 
!                                                                                  RAD_ALL.22475 
!     BLOCK 9:                                                                     RAD_ALL.22476 
      IF (L_PRESENT(9)) THEN                                                       RAD_ALL.22477 
         L_PRESENT_RD(9)=.TRUE.                                                    RAD_ALL.22478 
         DO I=1, N_BAND                                                            RAD_ALL.22479 
            DO J=1, N_BAND_CONTINUUM(I)                                            RAD_ALL.22480 
               I_CONTINUUM=INDEX_CONTINUUM(I, J)                                   RAD_ALL.22481 
               I_SCALE_FNC_CONT_RD(I, I_CONTINUUM)                                 RAD_ALL.22482 
     &            =I_SCALE_FNC_CONT(I, I_CONTINUUM)                                RAD_ALL.22483 
               P_REF_CONTINUUM_RD(I_CONTINUUM, I)                                  RAD_ALL.22484 
     &            =P_REF_CONTINUUM(I_CONTINUUM, I)                                 RAD_ALL.22485 
               T_REF_CONTINUUM_RD(I_CONTINUUM, I)                                  RAD_ALL.22486 
     &            =T_REF_CONTINUUM(I_CONTINUUM, I)                                 RAD_ALL.22487 
               K_CONTINUUM_RD(I, I_CONTINUUM)                                      RAD_ALL.22488 
     &            =K_CONTINUUM(I, I_CONTINUUM)                                     RAD_ALL.22489 
               DO L=1, N_SCALE_VARIABLE(I_SCALE_FNC_CONT                           RAD_ALL.22490 
     &               (I, I_CONTINUUM))                                             RAD_ALL.22491 
                  SCALE_CONTINUUM_RD(L, I, I_CONTINUUM)                            RAD_ALL.22492 
     &               =SCALE_CONTINUUM(L, I, I_CONTINUUM)                           RAD_ALL.22493 
               ENDDO                                                               RAD_ALL.22494 
            ENDDO                                                                  RAD_ALL.22495 
         ENDDO                                                                     RAD_ALL.22496 
      ENDIF                                                                        RAD_ALL.22497 
!                                                                                  RAD_ALL.22498 
!     BLOCK 10:                                                                    RAD_ALL.22499 
      IF (L_PRESENT(10)) THEN                                                      RAD_ALL.22500 
         L_PRESENT_RD(10)=.TRUE.                                                   RAD_ALL.22501 
         DO I=1, NPDR_DROP_TYPE                                                    RAD_ALL.22502 
            IF (L_DROP_TYPE(I)) THEN                                               RAD_ALL.22503 
               L_DROP_TYPE_RD(I)=.TRUE.                                            RAD_ALL.22504 
               I_DROP_PARAMETRIZATION_RD(I)=I_DROP_PARAMETRIZATION(I)              RAD_ALL.22505 
               DROP_PARM_MIN_DIM_RD(I)=DROP_PARM_MIN_DIM(I)                        RAD_ALL.22506 
               DROP_PARM_MAX_DIM_RD(I)=DROP_PARM_MAX_DIM(I)                        RAD_ALL.22507 
               IF (I_DROP_PARAMETRIZATION(I)                                       RAD_ALL.22508 
     &            .EQ.IP_SLINGO_SCHRECKER) THEN                                    RAD_ALL.22509 
                  N_PARAMETER=6                                                    RAD_ALL.22510 
               ELSE IF (I_DROP_PARAMETRIZATION(I)                                  RAD_ALL.22511 
     &            .EQ.IP_ACKERMAN_STEPHENS) THEN                                   RAD_ALL.22512 
                  N_PARAMETER=9                                                    RAD_ALL.22513 
               ENDIF                                                               RAD_ALL.22514 
!                                                                                  RAD_ALL.22515 
               DO J=1, N_PARAMETER                                                 RAD_ALL.22516 
                  DO K=1, N_BAND                                                   RAD_ALL.22517 
                     DROP_PARAMETER_LIST_RD(J, K, I)                               RAD_ALL.22518 
     &                  =DROP_PARAMETER_LIST(J, K, I)                              RAD_ALL.22519 
                  ENDDO                                                            RAD_ALL.22520 
               ENDDO                                                               RAD_ALL.22521 
            ELSE                                                                   RAD_ALL.22522 
               L_DROP_TYPE_RD(I)=.FALSE.                                           RAD_ALL.22523 
            ENDIF                                                                  RAD_ALL.22524 
         ENDDO                                                                     RAD_ALL.22525 
      ENDIF                                                                        RAD_ALL.22526 
!                                                                                  RAD_ALL.22527 
!     BLOCK 11:                                                                    RAD_ALL.22528 
      IF (L_PRESENT(11)) THEN                                                      RAD_ALL.22529 
         L_PRESENT_RD(11)=.TRUE.                                                   RAD_ALL.22530 
         DO I=1, N_AEROSOL_RETAIN                                                  RAD_ALL.22531 
            I_INITIAL=INDEX_AEROSOL_RETAIN(I)                                      RAD_ALL.22532 
            IF (L_AEROSOL_SPECIES(I_INITIAL)) THEN                                 RAD_ALL.22533 
               L_AEROSOL_SPECIES_RD(I)=.TRUE.                                      RAD_ALL.22534 
               I_AEROSOL_PARAMETRIZATION_RD(I)                                     RAD_ALL.22535 
     &            =I_AEROSOL_PARAMETRIZATION(I_INITIAL)                            RAD_ALL.22536 
               IF (I_AEROSOL_PARAMETRIZATION(I_INITIAL)                            RAD_ALL.22537 
     &            .EQ.IP_AEROSOL_PARAM_DRY) THEN                                   RAD_ALL.22538 
                  NHUMIDITY_RD(I)=0                                                RAD_ALL.22539 
                  DO K=1, N_BAND                                                   RAD_ALL.22540 
                     AEROSOL_ABSORPTION_RD(1, I, K)                                RAD_ALL.22541 
     &                  =AEROSOL_ABSORPTION(1, I_INITIAL, K)                       RAD_ALL.22542 
                     AEROSOL_SCATTERING_RD(1, I, K)                                RAD_ALL.22543 
     &                  =AEROSOL_SCATTERING(1, I_INITIAL, K)                       RAD_ALL.22544 
                     AEROSOL_ASYMMETRY_RD(1, I, K)                                 RAD_ALL.22545 
     &                  =AEROSOL_ASYMMETRY(1, I_INITIAL, K)                        RAD_ALL.22546 
                  ENDDO                                                            RAD_ALL.22547 
               ELSE IF (I_AEROSOL_PARAMETRIZATION(I_INITIAL)                       RAD_ALL.22548 
     &            .EQ.IP_AEROSOL_PARAM_MOIST) THEN                                 RAD_ALL.22549 
                  INDEX_WATER_RD=INDEX_WATER                                       RAD_ALL.22550 
                  NHUMIDITY_RD(I)=NHUMIDITY(I_INITIAL)                             RAD_ALL.22551 
                  DO J=1, NHUMIDITY(I_INITIAL)                                     RAD_ALL.22552 
                     HUMIDITIES_RD(J, I)=HUMIDITIES(J, I_INITIAL)                  RAD_ALL.22553 
                     DO K=1, N_BAND                                                RAD_ALL.22554 
                        AEROSOL_ABSORPTION_RD(J, I, K)                             RAD_ALL.22555 
     &                     =AEROSOL_ABSORPTION(J, I_INITIAL, K)                    RAD_ALL.22556 
                        AEROSOL_SCATTERING_RD(J, I, K)                             RAD_ALL.22557 
     &                     =AEROSOL_SCATTERING(J, I_INITIAL, K)                    RAD_ALL.22558 
                        AEROSOL_ASYMMETRY_RD(J, I, K)                              RAD_ALL.22559 
     &                     =AEROSOL_ASYMMETRY(J, I_INITIAL, K)                     RAD_ALL.22560 
                     ENDDO                                                         RAD_ALL.22561 
                  ENDDO                                                            RAD_ALL.22562 
               ENDIF                                                               RAD_ALL.22563 
!                                                                                  RAD_ALL.22564 
            ELSE                                                                   RAD_ALL.22565 
               L_AEROSOL_SPECIES_RD(I)=.FALSE.                                     RAD_ALL.22566 
            ENDIF                                                                  RAD_ALL.22567 
         ENDDO                                                                     RAD_ALL.22568 
      ENDIF                                                                        RAD_ALL.22569 
!                                                                                  RAD_ALL.22570 
!     BLOCK 12:                                                                    RAD_ALL.22571 
      IF (L_PRESENT(12)) THEN                                                      RAD_ALL.22572 
         L_PRESENT_RD(12)=.TRUE.                                                   RAD_ALL.22573 
         DO I=1, NPDR_ICE_TYPE                                                     RAD_ALL.22574 
            IF (L_ICE_TYPE(I)) THEN                                                RAD_ALL.22575 
               L_ICE_TYPE_RD(I)=.TRUE.                                             RAD_ALL.22576 
               ICE_PARM_MIN_DIM_RD(I)=ICE_PARM_MIN_DIM(I)                          RAD_ALL.22577 
               ICE_PARM_MAX_DIM_RD(I)=ICE_PARM_MAX_DIM(I)                          RAD_ALL.22578 
!                                                                                  RAD_ALL.22579 
               I_ICE_PARAMETRIZATION_RD(I)=I_ICE_PARAMETRIZATION(I)                RAD_ALL.22580 
               IF (I_ICE_PARAMETRIZATION(I)                                        RAD_ALL.22581 
     &            .EQ.IP_SLINGO_SCHRECKER_ICE) THEN                                RAD_ALL.22582 
                  N_PARAMETER=6                                                    RAD_ALL.22583 
               ELSE IF (I_ICE_PARAMETRIZATION(I)                                   RAD_ALL.22584 
     &            .EQ.IP_SUN_SHINE_VN2_VIS) THEN                                   RAD_ALL.22585 
                  N_PARAMETER=6                                                    RAD_ALL.22586 
               ELSE IF (I_ICE_PARAMETRIZATION(I)                                   RAD_ALL.22587 
     &            .EQ.IP_SUN_SHINE_VN2_IR) THEN                                    RAD_ALL.22588 
                  N_PARAMETER=0                                                    RAD_ALL.22589 
               ELSE IF (I_ICE_PARAMETRIZATION(I)                                   RAD_ALL.22590 
     &            .EQ.IP_ICE_ADT) THEN                                             RAD_ALL.22591 
                  N_PARAMETER=30                                                   RAD_ALL.22592 
               ENDIF                                                               RAD_ALL.22593 
!                                                                                  RAD_ALL.22594 
               DO J=1, N_PARAMETER                                                 RAD_ALL.22595 
                  DO K=1, N_BAND                                                   RAD_ALL.22596 
                     ICE_PARAMETER_LIST_RD(J, K, I)                                RAD_ALL.22597 
     &                  =ICE_PARAMETER_LIST(J, K, I)                               RAD_ALL.22598 
                  ENDDO                                                            RAD_ALL.22599 
               ENDDO                                                               RAD_ALL.22600 
            ELSE                                                                   RAD_ALL.22601 
               L_ICE_TYPE_RD(I)=.FALSE.                                            RAD_ALL.22602 
            ENDIF                                                                  RAD_ALL.22603 
         ENDDO                                                                     RAD_ALL.22604 
      ENDIF                                                                        RAD_ALL.22605 
!                                                                                  RAD_ALL.22606 
!     BLOCK 13:                                                                    RAD_ALL.22607 
      IF (L_PRESENT(13)) THEN                                                      RAD_ALL.22608 
         L_PRESENT_RD(13)=.TRUE.                                                   RAD_ALL.22609 
         DO I=1, N_ABSORB                                                          RAD_ALL.22610 
            L_DOPPLER_PRESENT_RD(I)=L_DOPPLER_PRESENT(I)                           RAD_ALL.22611 
            IF (L_DOPPLER_PRESENT(I)) THEN                                         RAD_ALL.22612 
               DOPPLER_CORRECTION_RD(I)=DOPPLER_CORRECTION(I)                      RAD_ALL.22613 
            ENDIF                                                                  RAD_ALL.22614 
         ENDDO                                                                     RAD_ALL.22615 
      ENDIF                                                                        RAD_ALL.22616 
!                                                                                  RAD_ALL.22617 
!                                                                                  RAD_ALL.22618 
!     BLOCK 14:                                                                    RAD_ALL.22619 
      IF (L_PRESENT(14)) THEN                                                      RAD_ALL.22620 
         L_PRESENT_RD(14)=.TRUE.                                                   RAD_ALL.22621 
         DO I=1, N_BAND                                                            RAD_ALL.22622 
             N_BAND_EXCLUDE_RD(I)=N_BAND_EXCLUDE(I)                                RAD_ALL.22623 
             DO J=1, N_BAND_EXCLUDE(I)                                             RAD_ALL.22624 
                INDEX_EXCLUDE_RD(J, I)=INDEX_EXCLUDE(J, I)                         RAD_ALL.22625 
             ENDDO                                                                 RAD_ALL.22626 
         ENDDO                                                                     RAD_ALL.22627 
      ENDIF                                                                        RAD_ALL.22628 
!                                                                                  RAD_ALL.22629 
!                                                                                  RAD_ALL.22630 
!                                                                                  RAD_ALL.22631 
      RETURN                                                                       RAD_ALL.22632 
      END  
